/****************************************************************************/
/*              Beebem - (c) David Alan Gilbert 1994                        */
/*              ------------------------------------                        */
/* This program may be distributed freely within the following restrictions:*/
/*                                                                          */
/* 1) You may not charge for this program or for any part of it.            */
/* 2) This copyright message must be distributed with all copies.           */
/* 3) This program must be distributed complete with source code.  Binary   */
/*    only distribution is not permitted.                                   */
/* 4) The author offers no warrenties, or guarentees etc. - you use it at   */
/*    your own risk.  If it messes something up or destroys your computer   */
/*    thats YOUR problem.                                                   */
/* 5) You may use small sections of code from this program in your own      */
/*    applications - but you must acknowledge its use.  If you plan to use  */
/*    large sections then please ask the author.                            */
/*                                                                          */
/* If you do not agree with any of the above then please do not use this    */
/* program.                                                                 */
/* Please report any problems to the author at beebem@treblig.org           */
/****************************************************************************/
/* The window which the beeb emulator displays stuff in */

#include <string.h>
#include <stdio.h>

#include "6502core.h"
#include "beebwin.h"
#include "disc8271.h"
#include "sysvia.h"
#include "video.h"

extern unsigned int FrameCount;

char* getScreenBufRow_p(unsigned int y){
	return (char*) frame_buffer_p->pixels+frame_buffer_p->pitch*y;
}


BeebWin::BeebWin() {
	cols[0]=SDL_MapRGB(frame_buffer_p->format, 0x00, 0x00, 0x00);
	cols[1]=SDL_MapRGB(frame_buffer_p->format, 0xff, 0x00, 0x00);
	cols[2]=SDL_MapRGB(frame_buffer_p->format, 0x00, 0xff, 0x00);
	cols[3]=SDL_MapRGB(frame_buffer_p->format, 0xff, 0xff, 0x00); 
	cols[4]=SDL_MapRGB(frame_buffer_p->format, 0x00, 0x00, 0xff);
	cols[5]=SDL_MapRGB(frame_buffer_p->format, 0xff, 0x00, 0xff);
	cols[6]=SDL_MapRGB(frame_buffer_p->format, 0x00, 0xff, 0xff);
	cols[7]=SDL_MapRGB(frame_buffer_p->format, 0xff, 0xff, 0xff);

	Frame=0;
	ShiftBooted = false;
}; /* BeebWin */

BeebWin::~BeebWin() {
}; /* Destructor */

unsigned int BeebWin::currentscanline(void){	
	return CurrentScanLine;
}

unsigned int BeebWin::currentframe(void){
//==	return Frame;
	return FrameCount;
}

// [TODO] Loose starty and nlines, always updates the whole framebuffer anyway.
void BeebWin::updateLines(int starty, int nlines) {

//==	Frame = Frame +1;	
	if ( ((mainWin->currentframe())&1)==0) SDL_UpdateRect(frame_buffer_p, 0, 0, frame_buffer_p->w,frame_buffer_p->h);

	//SDL_UpdateRect(frame_buffer_p, 0, starty, frame_buffer_p->w, nlines);
	//SDL_UpdateRect(frame_buffer_p, 0, 0, frame_buffer_p->w,frame_buffer_p->h);
	//SDL_UpdateRect(frame_buffer_p, 0,0,320,256);

}; /* BeebWin::updateLines */

EightUChars *BeebWin::GetLinePtr(int y) {

  if (y<0) y=0;
  if (y>=240) y=240-1;

  // [TODO] Check what uses CurrentScanLine, why's it set here?
  CurrentScanLine=(unsigned int) y;
  return( (EightUChars *) getScreenBufRow_p(y) );
};

SixteenUChars *BeebWin::GetLinePtr16(int y) {

  if (y<0) y=0;
  if (y>=240) y=240-1;

  // [TODO] Check what uses CurrentScanLine, why's it set here?
  CurrentScanLine=(unsigned int) y;

  return( (SixteenUChars *) getScreenBufRow_p(y) );
};
