#ifndef _KEYBOARD_HEADER
#define _KEYBOARD_HEADER

#include <SDL.h>

#define GP2X_BUTTON_UP              (0)
#define GP2X_BUTTON_DOWN            (4)
#define GP2X_BUTTON_LEFT            (2)
#define GP2X_BUTTON_RIGHT           (6)
#define GP2X_BUTTON_UPLEFT          (1)
#define GP2X_BUTTON_UPRIGHT         (7)
#define GP2X_BUTTON_DOWNLEFT        (3)
#define GP2X_BUTTON_DOWNRIGHT       (5)
#define GP2X_BUTTON_CLICK           (18)
#define GP2X_BUTTON_A               (12)
#define GP2X_BUTTON_B               (13)
#define GP2X_BUTTON_X               (15)
#define GP2X_BUTTON_Y               (14)
#define GP2X_BUTTON_L               (10)
#define GP2X_BUTTON_R               (11)
#define GP2X_BUTTON_START           (8)
#define GP2X_BUTTON_SELECT          (9)
#define GP2X_BUTTON_VOLUP           (16)
#define GP2X_BUTTON_VOLDOWN         (17)

/* Converts an SDL key into a BBC key.
 *
 */
struct BeebKeyTrans {
//  KeySym sym;
  int sym;
  int row;
  int col;
};

enum {JOY_UP, JOY_DOWN, JOY_LEFT, JOY_RIGHT, JOY_A, JOY_B, JOY_X, JOY_Y, JOY_SELECT};


int ConvertSDLKeyToBBCKey(int sym, int *col, int *row);

int gp2xButtonToSDLK(int button);
int apply_mapping(int gp2xButton, int sdlk);
int buttonnameToGP2XButton(char* name);
int keynameToSDLK( char* name);

void HandleButtonPress(int pressed, int joy);
void HandleButtonPressForKeysym(int pressed, int keysym);
void AllDirectionButtonsUp();

int kbd_load_mapping(char *kbd_filename);

#endif
