/****************************************************************************/
/*              Beebem - (c) David Alan Gilbert 1994/1995                   */
/*              -----------------------------------------                   */
/* This program may be distributed freely within the following restrictions:*/
/*                                                                          */
/* 1) You may not charge for this program or for any part of it.            */
/* 2) This copyright message must be distributed with all copies.           */
/* 3) This program must be distributed complete with source code.  Binary   */
/*    only distribution is not permitted.                                   */
/* 4) The author offers no warrenties, or guarentees etc. - you use it at   */
/*    your own risk.  If it messes something up or destroys your computer   */
/*    thats YOUR problem.                                                   */
/* 5) You may use small sections of code from this program in your own      */
/*    applications - but you must acknowledge its use.  If you plan to use  */
/*    large sections then please ask the author.                            */
/*                                                                          */
/* If you do not agree with any of the above then please do not use this    */
/* program.                                                                 */
/* Please report any problems to the author at beebem@treblig.org           */
/****************************************************************************/
/* Beeb emulator - main file */

// BeebDiscLoad0=S:80:/home/max/test/DiscImages/Superior/Pipeline.ssd

/*

*	at_exit isn't called for some reason

*	add a resources.cc file that uses getcwd. 
*	add command line parser (which can load discs and keymappings).


DONE	Test GP2x with a USB keyboard. Does not work.
DONE	Disable 25HZ fudge for now.
DONE	Investigate regulating timing (via frame change - beeb do time).
DONE	Remove all gtk code, make 100% SDL
DONE	Remove all 'extras' I added for the gtk version. I want it lean and mean.
*	Fix all warnings.

DONE	Add SDL keyboard support + add additional keys to fake special keys via console.

*	Convert to a C application.

DONE	Install new graphics code.
*	Convert to faster rendering method.
DONE	Fix line drawing so it's always within bounds.

DONE	Think of a way of reducing the frame rate.
*	Is the fast-table being regenerated too often for split screens? The fast-table is called all the time, fix it.

DONE	Test video code for out of bounds.

DONE	Reduce screen size to target size.
*	Fix teletext so that it uses the scaling tables. (So we can show the keyboard too).

DONE	Hack shift loading. (just make sure for first emulated second shift is down).

DONE	Add compiling support for GP2x.

*	Milestone: Test on GP2x, does it run at full speed?

*	New Teletext font (more like 3.5).

*	Fix keyboard so it reads from the console.
*	Check that keyboard bug is not happening.

*	Timer based shift loading.

*	Think about the on-screen keyboard.
*	Think about how GP2x keys are going to work (plus assign them on the keypad and read from the console).
*	Think about how keys can be re-assigned for each game.

*	Add keyboard support (do not use SDL).

*	Harmonise the emulator core with 3.5.
*	Harmonise the teletext code with 3.5.

*	Port the sound code from 3.5.
*	Investigate + implement save state.

*	Investigate making sound on 940T.

*	4bpp video support - loose SDL.
*	4bpp video support in assembler.
*	Sound on 940T.
*	A teletext mode that uses the blitter.

*	[TBD] Simple GUI?


*/


#include <signal.h>
#include <stdio.h>
#include <stdlib.h>

#include <iostream>

#include "6502core.h"
#include "beebmem.h"
#include "beebsound.h"
#include "sysvia.h"
#include "uservia.h"
#include "beebwin.h"
#include "disc8271.h"
#include "video.h"
#include "keyboard.h"

#include <stdio.h>

#include <SDL.h>
SDL_Surface *frame_buffer_p=NULL;

#include "via.h"
extern VIAState SysVIAState;
BeebWin *mainWin;

static char *Banner=
#include "header"
;

static char *Version="BeebEm for GP2x";

//#ifdef GP2X
///* GP2X button mapping:
// */
//
//#	define GP2X_BUTTON_UP              (0)
//#	define GP2X_BUTTON_DOWN            (4)
//#	define GP2X_BUTTON_LEFT            (2)
//#	define GP2X_BUTTON_RIGHT           (6)
//#	define GP2X_BUTTON_UPLEFT          (1)
//#	define GP2X_BUTTON_UPRIGHT         (7)
//#	define GP2X_BUTTON_DOWNLEFT        (3)
//#	define GP2X_BUTTON_DOWNRIGHT       (5)
//#	define GP2X_BUTTON_CLICK           (18)
//#	define GP2X_BUTTON_A               (12)
//#	define GP2X_BUTTON_B               (13)
//#	define GP2X_BUTTON_X               (14)
//#	define GP2X_BUTTON_Y               (15)
//#	define GP2X_BUTTON_L               (10)
//#	define GP2X_BUTTON_R               (11)
//#	define GP2X_BUTTON_START           (8)
//#	define GP2X_BUTTON_SELECT          (9)
//#	define GP2X_BUTTON_VOLUP           (16)
//#	define GP2X_BUTTON_VOLDOWN         (17)
//
//static struct BeebKeyTrans GP2XtoBeebEmKeymap[]={
// GP2X                 BBC                BBC KEY NAME
//{GP2X_BUTTON_Y,		6,2},		// SPACE
//{GP2X_BUTTON_A,		4,9},		// RETURN
//{GP2X_BUTTON_LEFT,	4,0},		// CAPS LOCK
//{GP2X_BUTTON_UPLEFT,	4,0},		// CAPS LOCK
//{GP2X_BUTTON_DOWNLEFT,	4,0},		// CAPS LOCK
//{GP2X_BUTTON_RIGHT,	0,1},		// CONTROL
//{GP2X_BUTTON_UPRIGHT,	0,1},		// CONTROL
//{GP2X_BUTTON_DOWNRIGHT,	0,1},		// CONTROL
//
//{-1, -1, -1}              // ** END OF LIST **
//};
//
//int ConvertGP2XButtonToBBCKey(int button, int *col, int *row)
//{
//        struct BeebKeyTrans *p = GP2XtoBeebEmKeymap;
//
//        for(;((p->row != -1) && (p->sym != button));p++) {}
//
//        *(row) = p->row;
//        *(col) = p->col;
//
//        return *row<0 ? 0 : 1;
//}
//#endif

void at_exit(void)
{
	printf("running at_exit\n");
	SDL_Quit();	

#ifdef GP2X
	printf("loading GP2X menu\n");
	chdir("/usr/gp2x");
	execl("/usr/gp2x/gp2xmenu", "/usr/gp2x/gp2xmenu", NULL);
#endif
}


int main(int argc,char *argv[]) {
	char mapping[256], *file_type_p, *filename_p;
	int flags;
#ifdef GP2X
	SDL_Joystick *joystick_p = NULL;
#endif

	/* Print start message on console:
	 */

	std::cout << Banner << "\n" << "Version: " << Version << "\n";


	/* Initialize SDL:
	 */

	flags = SDL_INIT_VIDEO /* | SDL_INIT_AUDIO */ ;
#ifdef GP2X
	flags |= SDL_INIT_JOYSTICK;
#endif
	if (SDL_Init(flags) <0) {
		fprintf(stderr, "Unable to initialise SDL: %s\n"
		 , SDL_GetError());
		return false;
	}

#ifndef GP2X
	/* Cleanup SDL when exiting.
	 */

	// [TODO] For GP2x we need to reload the menu on a crash.
	atexit(at_exit);
#endif

	/* Setup a frame buffer to play with.
	 */
	flags = SDL_SWSURFACE | SDL_HWPALETTE;
//	if ( (frame_buffer_p=SDL_SetVideoMode(800, 600, 8, flags)) == NULL ) {
	if ( (frame_buffer_p=SDL_SetVideoMode(320, 240, 8, flags)) == NULL ) {
		fprintf(stderr, "Unable to set video mode: %s\n"
		 , SDL_GetError());
		exit(1);
	}
#ifdef GP2X
	SDL_ShowCursor(SDL_DISABLE);
#endif

#ifdef GP2X
	if ( (joystick_p=SDL_JoystickOpen(0) ) == NULL) {
		fprintf(stderr, "Couldn't open the joystick: %s\n"
		 , SDL_GetError());
		exit(1);
	}
#endif

#ifndef GP2X
	/* Fill screen with some boxes to denote boundries.
	 */
	SDL_FillRect(frame_buffer_p, NULL, SDL_MapRGB(frame_buffer_p->format
	 , 0xff, 0x00, 0x00));
	SDL_Rect rect= {0, 0, 322, 258};
	Uint32 color = SDL_MapRGB(frame_buffer_p->format, 0xff, 0xff, 0x00);
	SDL_FillRect(frame_buffer_p, &rect, color);
	SDL_UpdateRect(frame_buffer_p, 0, 0, frame_buffer_p->w
	 , frame_buffer_p->h);
	
	rect= (SDL_Rect) {0, 0, 322, 242};
	color = SDL_MapRGB(frame_buffer_p->format, 0x00, 0xff, 0xff);
	SDL_FillRect(frame_buffer_p, &rect, color);
	SDL_UpdateRect(frame_buffer_p, 0,0,frame_buffer_p->w,frame_buffer_p->h);
#endif


	/* Initialize abstracted host environment.
	 */
	// [TODO] Get rid of this, use normal C calls to everything in here, everything is hardwired to mainWin anyway.
	mainWin=new BeebWin();

	/* Initialize emulator core:
	 */
	BeebMemInit();
  	Init6502core();
 	SysVIAReset();
#ifdef SOUNDSUPPORT
  	SoundInit();
#endif
  	UserVIAReset();
  	VideoInit();
  	Disc8271_reset();


#ifdef GP2X
	SetCPUSpeed(200);
#endif


	/* Load disc hack (for now):
	 */

	if (argc>1) {
		filename_p = argv[1];

		if ( (file_type_p=strrchr(filename_p, (int) '.')) == NULL) {
			printf("Supplied disc image filename does not have a file extension.\n");
			exit(1);
		}
	
		printf("Loading disc image '%s'\n", filename_p);

		if (strcasecmp(file_type_p, ".ssd") == 0) 
			LoadSimpleDiscImage(filename_p, 0, 0, 80);
		else if (strcasecmp(file_type_p, ".dsd") == 0)
			LoadSimpleDSDiscImage(filename_p, 0, 80);
		else {
			printf("Unsupported disc image.\n");
			exit(1);
		}

		if (argc == 2) {
			strncpy(mapping, filename_p, strlen(filename_p)-strlen(file_type_p));
			mapping[strlen(filename_p)-strlen(file_type_p)]='\0';
			strcat(mapping, ".kbd");
		} else {
			strcpy(mapping, argv[2]);
		}

		printf("Loading button mapping '%s'\n", mapping);

		kbd_load_mapping(mapping);
	} else {
		printf("No disc image specified\n");
	}



	/* Main loop:
	 */

	/* Shift boot the GP2X for now
	 */
	// [TODO] Make this time based and dump key presses within under the first half second.
	mainWin->ShiftBooted = true;
	BeebKeyDown(0, 0);

	int done, col, row;
	done = col = row = 0;
	do {

		SDL_Event event;
		while (SDL_PollEvent(&event)) {
			switch (event.type) {
				
				case SDL_QUIT:
					done=1;
					break;

				case SDL_KEYDOWN:
					/* Handle shift booting:
					 */
					if (mainWin->ShiftBooted) {
						mainWin->ShiftBooted = false;
						BeebKeyUp(0, 0);
					}
					if ( ConvertSDLKeyToBBCKey( event.key.keysym.sym, &col, &row) )
						BeebKeyDown(row, col);
					else if (row == -2) {
						/* Handle reset */
						Init6502core();
						Disc8271_reset();
					}
					break;

				case SDL_KEYUP:
					if ( ConvertSDLKeyToBBCKey(event.key.keysym.sym, &col, &row) )
						BeebKeyUp(row, col);
					break;

#ifdef GP2X
//				case SDL_JOYBUTTONDOWN:
//
//					if ( event.jbutton.button == GP2X_BUTTON_START )
//						done = 1;
//
//					if (mainWin->ShiftBooted) {
//						mainWin->ShiftBooted = false;
//						BeebKeyUp(0, 0);
//					}
//					if ( ConvertGP2XButtonToBBCKey(
//					 event.jbutton.button, &col, &row) )
//						BeebKeyDown(row, col);
//					else if (row == -2) {
//						Init6502core();
//						Disc8271_reset();
//					}
//					break;
//
//				case SDL_JOYBUTTONUP:
//					if ( ConvertGP2XButtonToBBCKey(
//					 event.jbutton.button, &col, &row) )
//						 BeebKeyUp(row, col);
//					break;


                        case SDL_JOYBUTTONDOWN:
                        case SDL_JOYBUTTONUP:
                                {
                                        // Reset shift state if it was set by Run Disc
                                        if (mainWin->ShiftBooted)
                                        {
                                                mainWin->ShiftBooted = false;
                                                BeebKeyUp(0, 0);
                                        }

                                        int pressed=0, ordinalHit=0;
                                        //SDL_keysym keysym;
                                        int keysym = 0;
                                        //keysym.sym = SDLK_UNKNOWN;
                                        if (event.jbutton.button == GP2X_BUTTON_START)
                                        {
						// [TODO] Menu.
						done=1;
                                        }
                                        else
                                        {
                                                if (event.jbutton.button == GP2X_BUTTON_LEFT ||
                                                        event.jbutton.button == GP2X_BUTTON_RIGHT ||
                                                        event.jbutton.button == GP2X_BUTTON_UP ||
                                                        event.jbutton.button == GP2X_BUTTON_DOWN)
                                                {
                                                        //printf("hit ordinal\n");
                                                        keysym = gp2xButtonToSDLK(event.jbutton.button);
                                                        //AllDirectionButtonsUp();
                                                        ordinalHit = 1;
                                                        HandleButtonPressForKeysym(event.type == SDL_JOYBUTTONDOWN, keysym);
                                                }
                                                else if (event.jbutton.button == GP2X_BUTTON_A ||
                                                        event.jbutton.button == GP2X_BUTTON_B ||
                                                        event.jbutton.button == GP2X_BUTTON_X ||
                                                        event.jbutton.button == GP2X_BUTTON_Y ||
                                                        event.jbutton.button == GP2X_BUTTON_SELECT)
                                                {
                                                        keysym = gp2xButtonToSDLK(event.jbutton.button);
                                                        HandleButtonPressForKeysym(event.type == SDL_JOYBUTTONDOWN, keysym);
                                                }

                                                if (event.jbutton.button == GP2X_BUTTON_UPLEFT)
                                                {
                                                        //printf("hit upleft\n");

                                                        if (!ordinalHit)
                                                                AllDirectionButtonsUp();

                                                        if (SDL_JoystickGetButton(joystick_p, GP2X_BUTTON_LEFT))
                                                        {
                                                                // weight it towards left
                                                                HandleButtonPress(1, JOY_LEFT);
                                                                HandleButtonPress(0, JOY_UP);
                                                                //printf("weighted left\n");
                                                        }
                                                        else if (SDL_JoystickGetButton(joystick_p, GP2X_BUTTON_UP))
                                                        {
                                                                // weight it towards up
                                                                HandleButtonPress(1, JOY_UP);
                                                                HandleButtonPress(0, JOY_LEFT);
                                                                //printf("weighted up\n");
                                                        }
                                                        else
                                                        {
                                                                // do both
                                                                HandleButtonPress(event.type == SDL_JOYBUTTONDOWN, JOY_UP);
                                                                HandleButtonPress(event.type == SDL_JOYBUTTONDOWN, JOY_LEFT);
                                                        }
                                                }
                                                else if (event.jbutton.button == GP2X_BUTTON_UPRIGHT)
                                                {
                                                        //printf("hit upright\n");
                                                        if (!ordinalHit)
                                                                AllDirectionButtonsUp();

                                                        if (SDL_JoystickGetButton(joystick_p, GP2X_BUTTON_RIGHT))
                                                        {
                                                                // weight it towards right
                                                                HandleButtonPress(1, JOY_RIGHT);
                                                                HandleButtonPress(0, JOY_UP);
                                                                //printf("weighted right\n");
                                                        }
                                                        else if (SDL_JoystickGetButton(joystick_p, GP2X_BUTTON_UP))
                                                        {
                                                                // weight it towards up
                                                                HandleButtonPress(1, JOY_UP);
                                                                HandleButtonPress(0, JOY_RIGHT);
                                                                //printf("weighted up\n");
                                                        }
                                                        else
                                                        {
                                                                HandleButtonPress(event.type == SDL_JOYBUTTONDOWN, JOY_UP);
                                                                HandleButtonPress(event.type == SDL_JOYBUTTONDOWN, JOY_RIGHT);
                                                        }
                                                }
                                                else if (event.jbutton.button == GP2X_BUTTON_DOWNLEFT)
                                                {
                                                        //printf("hit downleft\n");
                                                        if (!ordinalHit)
                                                                AllDirectionButtonsUp();

                                                        if (SDL_JoystickGetButton(joystick_p, GP2X_BUTTON_LEFT))
                                                        {
                                                                // weight it towards left
                                                                HandleButtonPress(1, JOY_LEFT);
                                                                HandleButtonPress(0, JOY_DOWN);
                                                                //printf("weighted left\n");
                                                        }
                                                        else if (SDL_JoystickGetButton(joystick_p, GP2X_BUTTON_DOWN))
                                                        {
                                                                // weight it towards down
                                                                HandleButtonPress(1, JOY_DOWN);
                                                                HandleButtonPress(0, JOY_LEFT);
                                                                //printf("weighted down\n");
                                                        }
                                                        else
                                                        {
                                                                HandleButtonPress(event.type == SDL_JOYBUTTONDOWN, JOY_DOWN);
                                                                HandleButtonPress(event.type == SDL_JOYBUTTONDOWN, JOY_LEFT);
                                                        }

                                                }
                                                else if (event.jbutton.button == GP2X_BUTTON_DOWNRIGHT)
                                                {
                                                        //printf("hit downright\n");

                                                        if (!ordinalHit)
                                                                AllDirectionButtonsUp();

                                                        if (SDL_JoystickGetButton(joystick_p, GP2X_BUTTON_RIGHT))
                                                        {
                                                                // weight it towards right
                                                                HandleButtonPress(event.type == SDL_JOYBUTTONDOWN, JOY_RIGHT);
                                                                HandleButtonPress(0, JOY_DOWN);
                                                                //printf("weighted right\n");
                                                        }
                                                        else if (SDL_JoystickGetButton(joystick_p, GP2X_BUTTON_DOWN))
                                                        {
                                                                // weight it towards down
                                                                HandleButtonPress(event.type == SDL_JOYBUTTONDOWN, JOY_DOWN);
                                                                HandleButtonPress(0, JOY_RIGHT);
                                                                //printf("weighted down\n");
                                                        }
                                                        else
                                                        {
                                                                HandleButtonPress(event.type == SDL_JOYBUTTONDOWN, JOY_DOWN);
                                                                HandleButtonPress(event.type == SDL_JOYBUTTONDOWN, JOY_RIGHT);
                                                        }
                                                }
                                        }

                                        if (keysym != 0)
                                        {
                                                /* Handle reset:
                                                 */
                                                if(row==-2)
                                                {
	                                              Init6502core();
        	                                      Disc8271_reset();
                                                }
                                        }
                                }
                                break;
#endif

			}
		}

		/* Actually will exec. approx. half a frame of cycles (good
		 * enough hack for now).
		 */
		Exec6502Instruction();

	} while (! done);

  at_exit();
  return 0;
}
