#include <SDL.h>

#ifdef GP2X
#       include <sys/mman.h>
#       include <sys/stat.h>
#       include <fcntl.h>
#       include <sys/ioctl.h>
#       include <sys/soundcard.h>
#       include <sys/time.h>
#       include <sys/resource.h>
#       include <sys/types.h>
#       include <unistd.h>
#       include <string.h>
#       include <stdlib.h>
#endif


#define MIN_OS_WAIT_TIME	100

static void BusyWait(Uint32 u32TimeShouldWait, Uint32 u32StartTickCount)
{
        Uint32 u32AjustedTime;

        do{
                u32AjustedTime = SDL_GetTicks();

                /* Handle wrap around after ~47 days of continued execution
                 */
                if (u32AjustedTime < u32StartTickCount)
                        u32AjustedTime = u32AjustedTime
                         + ( ((Uint32) 0xffffffff) - u32StartTickCount);
                else
                        u32AjustedTime = u32AjustedTime - u32StartTickCount;

        }while(u32AjustedTime < u32TimeShouldWait);
}

void SDL_Sleep(unsigned int ticks)
{
        /* Do nothing if BeebEm asked to wait 0 ms.
         */
        if (ticks<1) return;

        // Only sleep if we are sure the OS can honnor it, busywait otherwise:
//        if(ticks >= MIN_OS_WAIT_TIME){
#ifndef GP2X
               SDL_Delay(ticks);
//        }else{
#else
                BusyWait(ticks, SDL_GetTicks());
#endif
//        }
}

#ifdef GP2X
//static volatile Uint8 *gp2x_ram;
//static volatile Uint8 *gp2x_ram2;
static volatile Uint16 *gp2x_memregs;
static volatile Uint32 *gp2x_memregl;
static int gp2x_dev_mem=NULL;

void SetCPUSpeed(unsigned int MHZ)
{
#define SYS_CLK_FREQ 7372800

        if (gp2x_dev_mem == NULL) {
		gp2x_dev_mem = open("/dev/mem",   O_RDWR);
//        	gp2x_ram=(Uint8 *)mmap(0, 0x1000000, PROT_READ|PROT_WRITE, MAP_SHARED, gp2x_dev_mem, 0x02000000);
//      	gp2x_ram2=(Uint8 *)mmap(0, 0x1000000, PROT_READ|PROT_WRITE, MAP_SHARED, gp2x_dev_mem, 0x03000000);
        	gp2x_memregl=(Uint32 *)mmap(0, 0x10000, PROT_READ|PROT_WRITE, MAP_SHARED, gp2x_dev_mem, 0xc0000000);
        	gp2x_memregs=(Uint16*)gp2x_memregl;
		close(gp2x_dev_mem);
	}

        unsigned v;
        unsigned mdiv,pdiv=3,scale=0;
        MHZ*=1000000;
        mdiv=(MHZ*pdiv)/SYS_CLK_FREQ;
        mdiv=((mdiv-8)<<8) & 0xff00;
        pdiv=((pdiv-2)<<2) & 0xfc;
        scale&=3;
        v=mdiv | pdiv | scale;
        gp2x_memregs[0x910>>1]=v;
}
#else
void SetCPUSpeed(unsigned int MHZ) {}
#endif

